Subject: Re: bug#58728: 29.0.50; Minibuffer does not follow tabs

From: Juri Linkov <[email-masked]>
Date: Fri, 28 Oct 2022 09:40:46 +0300

>>     1. emacs -Q
>>     2. M-: (setq wc (current-window-configuration))
>>     3. M-x
>>     4. M-: (set-window-configuration wc)
>>     5. ???
>>     6. The minibuffer with its window is restored and reactivated.
>>
>> Maybe something like what frameset-to-register/jump-to-register does,
>> that restores the minibuffer, but doesn't reactivate it.
>
> Without putting much effort, I ended up with the following expression
> after a quick C-h d for "minibuffer"
>
>     (set-window-buffer (minibuffer-window) (get-buffer (format " *Minibuf-%d*" (minibuffer-depth))))

This works only for the recent minibuffer, but not for recursive minibuffers
with arbitrary depths, such as

    1. emacs -Q
    2. M-: (setq wc (current-window-configuration))
    3. C-x C-f
    4. M-x
    5. M-: (set-window-configuration wc)
    6. M-: (set-window-buffer (minibuffer-window) (get-buffer (format " *Minibuf-%d*" (minibuffer-depth))))
    7. C-g

The first minibuffer is not displayed.  But OTOH, window-state
handles it correctly, because it just doesn't mess with minibuffers:

    1. emacs -Q
    2. M-: (setq ws (window-state-get (frame-root-window) t))
    3. C-x C-f
    4. M-x
    5. M-: (window-state-put ws (frame-root-window) 'safe)
    6. C-g

> I am not sure how well this will work with minibuffer-only-frames and
> such though.  We need to select the minibuffer when switching the tab if
> the minibuffer was selected prior to the switch too, but that's a matter
> of (select-window (minibuffer-window)) I think.

For making it more like minibuffer-only-frames, there are more questions.
After switching to another frame and exiting the minibuffer, it switches
back to the original frame to execute the command, e.g.:

    1. emacs -Q
    2. C-x 5 5 C-h i
    3. M-x
    4. C-x 5 o
    5. C-x o   (need to switch to the minibuffer because switching frames
                doesn't select the minibuffer, maybe a bug?)
    6. count-words RET

The command 'count-words' is executed in the original frame.
What should tab-bar.el do?  Select the original tab before
executing the minibuffer command?